stages:
    - build
    - test
    - deploy-dev
    - deploy-stg
    - deploy
build:
    stage: build
    image: node:10.16.3-alpine
    script:
        - npm install
        - npm run build
unit_test:
    stage: test
    image: node:10.16.3-alpine
    script:
        - npm install
        - npm run test
deploy_heroku_dev:
    stage: deploy-dev
    image: ruby:2.3
    script:
        - apt update
        - gem install dpl
        - dpl --provider=heroku --app=$HEROKU_APP_NAME_DEV --api-key=$HEROKU_API_KEY
    only:
        - branches
    except:
        - master
        - tags
deploy_heroku_stg:
    stage: deploy-stg
    script:
        - npm install
        - npm run build
        - pm2 delete server || true 
        - pm2 start dist/server.js --name server
    only:
        - master
    tags:
        - deploy_production
deploy_heroku:
    stage: deploy
    script:
        - npm install
        - npm run build
        - npm run start
    only: 
        - tags
    tags:
        - deploy_production